Loading...
Searching...
No Matches
Opm::RichardsModel< TypeTag > Class Template Reference

This model implements a variant of the Richards equation for quasi-twophase flow. More...

`#include <richardsmodel.hh>`

Inheritance diagram for Opm::RichardsModel< TypeTag >:

## Public Member Functions

| RichardsModel (Simulator &simulator)
std::string | primaryVarName (unsigned pvIdx) const
| Given an primary variable index, return a human readable name.
std::string | eqName (unsigned eqIdx) const
| Given an equation index, return a human readable name.
Scalar | primaryVarWeight (unsigned, unsigned pvIdx) const
| Returns the relative weight of a primary variable for calculating relative errors.
Scalar | eqWeight (unsigned, unsigned eqIdx) const
| Returns the relative weight of an equation.
void | updateBegin ()
| Called by the update() method before it tries to apply the newton method.
bool | phaseIsConsidered (unsigned phaseIdx) const
void | registerOutputModules_ ()
Public Member Functions inherited from Opm::MultiPhaseBaseModel< TypeTag >
| MultiPhaseBaseModel (Simulator &simulator)
bool | phaseIsConsidered (unsigned) const
| Returns true iff a fluid phase is used by the model.
void | globalPhaseStorage (EqVector &storage, unsigned phaseIdx)
| Compute the total storage inside one phase of all conservation quantities.
void | registerOutputModules_ ()

## Static Public Member Functions

static void | registerParameters ()
| Register all run-time parameters for the model.
static std::string | name ()
Static Public Member Functions inherited from Opm::MultiPhaseBaseModel< TypeTag >
static void | registerParameters ()
| Register all run-time parameters for the immiscible model.

## Public Attributes

Scalar | referencePressure_ {}

## Detailed Description

template<class TypeTag>
class Opm::RichardsModel< TypeTag >

This model implements a variant of the Richards equation for quasi-twophase flow.

In the unsaturated zone, Richards' equation is frequently used to approximate the water distribution above the groundwater level. It can be derived from the two-phase equations, i.e.

where is the index of the fluid phase, is the fluid density, is the fluid saturation, is the porosity of the soil, is the relative permeability for the fluid, is the fluid's dynamic viscosity, is the intrinsic permeability tensor, is the fluid phase pressure and is the potential of the gravity field.

In contrast to the "full" two-phase model, the Richards model assumes that the non-wetting fluid is gas and that it thus exhibits a much lower viscosity than the (liquid) wetting phase. (This assumption is quite realistic in many applications: For example, at atmospheric pressure and at room temperature, the viscosity of air is only about of the viscosity of liquid water.) As a consequence, the term typically is much larger for the gas phase than for the wetting phase. Using this reasoning, the Richards model assumes that is infinitely large compared to the same term of the liquid phase. This implies that the pressure of the gas phase is equivalent to the static pressure distribution and that therefore, mass conservation only needs to be considered for the liquid phase.

The model thus choses the absolute pressure of the wetting phase as its only primary variable. The wetting phase saturation is calculated using the inverse of the capillary pressure, i.e.

holds, where is a reference pressure given by the problem's `referencePressure()` method. Nota bene, that the last step assumes that the capillary pressure-saturation curve can be uniquely inverted, i.e. it is not possible to set the capillary pressure to zero if the Richards model ought to be used!

## Member Function Documentation

## eqName()

template<class TypeTag>

std::string Opm::RichardsModel< TypeTag >::eqName | ( | unsigned | eqIdx | ) | const

inline

Given an equation index, return a human readable name.

Parameters

  eqIdx | The index of the conservation equation of interest.

## eqWeight()

template<class TypeTag>

Scalar Opm::RichardsModel< TypeTag >::eqWeight | ( | unsigned | ,
|  | unsigned | eqIdx ) const

inline

Returns the relative weight of an equation.

Parameters

  globalVertexIdx | The global index of the vertex
  eqIdx | The index of the equation

## name()

template<class TypeTag>

std::string Opm::RichardsModel< TypeTag >::name | ( |  | ) |

inline static

## phaseIsConsidered()

template<class TypeTag>

bool Opm::RichardsModel< TypeTag >::phaseIsConsidered | ( | unsigned | phaseIdx | ) | const

inline

## primaryVarName()

template<class TypeTag>

std::string Opm::RichardsModel< TypeTag >::primaryVarName | ( | unsigned | pvIdx | ) | const

inline

Given an primary variable index, return a human readable name.

Parameters

  pvIdx | The index of the primary variable of interest.

## primaryVarWeight()

template<class TypeTag>

Scalar Opm::RichardsModel< TypeTag >::primaryVarWeight | ( | unsigned | ,
|  | unsigned | pvIdx ) const

inline

Returns the relative weight of a primary variable for calculating relative errors.

Parameters

  globalDofIdx | The global index of the degree of freedom
  pvIdx | The index of the primary variable

## registerParameters()

template<class TypeTag>

void Opm::RichardsModel< TypeTag >::registerParameters | ( |  | ) |

inline static

Register all run-time parameters for the model.

## updateBegin()

template<class TypeTag>

void Opm::RichardsModel< TypeTag >::updateBegin | ( |  | ) |

inline

Called by the update() method before it tries to apply the newton method.

This is primary a hook which the actual model can overload.

The documentation for this class was generated from the following file:

- opm/models/richards/richardsmodel.hh